searchNodes=[{"doc":"ChromicPDF is a fast HTML-to-PDF/A renderer based on Chrome &amp; Ghostscript. Usage Start Start ChromicPDF as part of your supervision tree: def MyApp.Application do def start(_type, _args) do children = [ # other apps... {ChromicPDF, chromic_pdf_opts()} ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end defp chromic_pdf_opts do [] end end Print a PDF or PDF/A ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}, output: &quot;output.pdf&quot;) See ChromicPDF.print_to_pdf/2 and ChromicPDF.convert_to_pdfa/2. Options Worker pools ChromicPDF spawns two worker pools, the session pool and the ghostscript pool. By default, it will create 5 workers with no overflow. To change these options, you can pass configuration to the supervisor. Please note that these are only worker pools. If you intend to max them out, you will need a job queue as well. Please see https://github.com/devinus/poolboy for available options. defp chromic_pdf_opts do [ session_pool: [ size: 3, max_overflow: 0 ], ghostscript_pool: [ size: 10, max_overflow: 2 ] ] end Automatic session restarts to avoid memory drain By default, ChromicPDF will restart sessions within the Chrome process after 1000 operations. This helps to prevent infinite growth in Chrome&#39;s overall memory consumption. This &quot;max age&quot; of a session can be configured by setting the :max_session_uses option. defp chromic_pdf_opts do [max_session_uses: 1000] end Security Considerations Before adding a browser to your application&#39;s (perhaps already long) list of dependencies, you may want consider the security hints below. Escape user-supplied data If you can, make sure to escape any data provided by users with something like Phoenix.HTML.escape_html. Chrome is designed to make displaying HTML pages relatively safe, in terms of preventing undesired access of a page to the host operating system. However, the attack surface of your application is still increased. Running this in a contained application with a small HTTP interface creates an additional barrier (and has other benefits). Running in online mode Browser targets will be spawned in &quot;offline mode&quot; by default (using the DevTools command Network.emulateNetworkConditions. Users are required to take this extra step (basically reading this paragraph) to re-consider whether remote printing is a requirement. However, there are a lot of valid use-cases for printing from a URL, particularly from a webserver on localhost. To switch to &quot;online mode&quot;, pass the offline: false parameter. def chromic_pdf_opts do [offline: false] end Chrome Sandbox By default, ChromicPDF will run Chrome targets in a sandboxed OS process. If you absolutely must run Chrome as root, you can turn of its sandbox by passing the no_sandbox: true option. defp chromic_pdf_opts do [no_sandbox: true] end How it works PDF Printing ChromicPDF spawns an instance of Chromium/Chrome (an OS process) and connects to its &quot;DevTools&quot; channel via file descriptors. The Chrome process is supervised and the connected processes will automatically recover if it crashes. A number of &quot;targets&quot; in Chrome are spawned, 1 per worker process in the SessionPool. By default, ChromicPDF will spawn each session in a new browser context (i.e., a profile). When a PDF print is requested, a session will instruct its assigned &quot;target&quot; to navigate to the given URL, then wait until it receives a &quot;frameStoppedLoading&quot; event, and proceed to call the printToPDF function. The printed PDF will be sent to the session as Base64 encoded chunks.","ref":"ChromicPDF.html","title":"ChromicPDF","type":"module"},{"doc":"Captures a screenshot. This call blocks until the screenshot has been created. Print and return Base64-encoded PNG {:ok, blob} = ChromicPDF.capture_screenshot({:url, &quot;file:///example.html&quot;}) Options Options can be passed by passing a map to the :capture_screenshot key. ChromicPDF.capture_screenshot( {:url, &quot;file:///example.html&quot;}, capture_screenshot: %{ format: &quot;jpeg&quot; } ) Please see docs for details: https://chromedevtools.github.io/devtools-protocol/tot/Page#method-captureScreenshot","ref":"ChromicPDF.html#capture_screenshot/2","title":"ChromicPDF.capture_screenshot/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"ChromicPDF.html#child_spec/1","title":"ChromicPDF.child_spec/1","type":"function"},{"doc":"Converts a PDF to PDF/A (either PDF/A-2b or PDF/A-3b). Convert an input PDF and return a Base64-encoded blob {:ok, blob} = ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;) Convert and write to file ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, output: &quot;output.pdf&quot;) PDF/A versions &amp; levels Ghostscript supports both PDF/A-2 and PDF/A-3 versions, both in their b (basic) level. By default, ChromicPDF generates version PDF/A-3b files. Set the pdfa_version option for version 2. ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, pdfa_version: &quot;2&quot;) Specifying PDF metadata The converter is able to transfer PDF metadata (the Info dictionary) from the original PDF file to the output file. However, files printed by Chrome do not contain any metadata information (except &quot;Creator&quot; being &quot;Chrome&quot;). The :info option of the PDF/A converter allows to specify metatadata for the output file directly. ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, info: %{creator: &quot;ChromicPDF&quot;}) The converter understands the following keys, all of which accept only String values: :title :author :subject :keywords :creator :creation_date :mod_date By specification, date values in :creation_date and :mod_date do not need to follow a specific syntax. However, Ghostscript inserts date strings like &quot;D:20200208153049+00&#39;00&#39;&quot; and Info extractor tools might rely on this or another specific format. The converter will automatically format given DateTime values like this. Both :creation_date and :mod_date are filled with the current date automatically (by Ghostscript), if the original file did not contain any. Adding more PostScript to the conversion The pdfa_def_ext option can be used to feed more PostScript code into the final conversion step. This can be useful to add additional features to the generated PDF-A file, for instance a ZUGFeRD invoice. ChromicPDF.convert_to_pdfa( &quot;some_pdf_file.pdf&quot;, pdfa_def_ext: &quot;[/Title (OverriddenTitle) /DOCINFO pdfmark&quot;, )","ref":"ChromicPDF.html#convert_to_pdfa/2","title":"ChromicPDF.convert_to_pdfa/2","type":"function"},{"doc":"Prints a PDF. This call blocks until the PDF has been created. Output options Print and return Base64-encoded PDF {:ok, blob} = ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}) # Can be displayed in iframes &quot;data:application/pdf;base64,\#{blob}&quot; Print to file :ok = ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}, output: &quot;output.pdf&quot;) Print to temporary file {:ok, :some_result} = ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}, output: fn path -&gt; send_download(path) :some_result end) The temporary file passed to the callback will be deleted when the callback returns. Input options Print from URL Passing in a URL is the simplest way of printing a PDF. A target in Chrome is told to navigate to the given URL. When navigation is finished, the PDF is printed. ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}) One may pass http or https URLs just like above, only be aware that you will need to enable &quot;online mode&quot; first. See &quot;Running in online mode&quot; for explanation. ChromicPDF.print_to_pdf({:url, &quot;http:///example.net&quot;}) Cookies If your URL requires authentication, you can pass in a session cookie. The cookie is automatically cleared after the PDF has been printed. cookie = %{ name: &quot;foo&quot;, value: &quot;bar&quot;, domain: &quot;localhost&quot; } ChromicPDF.print_to_pdf({:url, &quot;http:///example.net&quot;}, set_cookie: cookie) See Network.setCookie for options. name and value keys are required. Print from in-memory HTML For convenience, it is also possible to pass a HTML blob to print_to_pdf/2. The HTML is sent to the target using the Pahe.setDocumentContent function. ChromicPDF.print_to_pdf( {:html, &quot;&lt;h1&gt;Hello World!&lt;/h1&gt;&quot;} ) In-memory content can be iodata In-memory HTML for both the main input parameter as well as the header and footer options can be passed as iodata. Such lists are converted to String before submission to the session process by passing them through :erlang.iolist_to_binary/1. ChromicPDF.print_to_pdf( {:html, [&quot;&lt;style&gt;p { color: green; }&lt;/style&gt;&quot;, &quot;&lt;p&gt;green paragraph&lt;/p&gt;&quot;]} ) Content from Phoenix templates If your content is generated by a Phoenix template (and hence comes in the form of {:safe, iodata()}), you will need to pass it to Phoenix.HTML.safe_to_string/1 first. content = SomeView.render(&quot;body.html&quot;) |&gt; Phoenix.HTML.safe_to_string() ChromicPDF.print_to_pdf({:html, content}) PDF printing options ChromicPDF.print_to_pdf( {:url, &quot;file:///example.html&quot;}, print_to_pdf: %{ pageRanges: &quot;1-2&quot; } ) Please note the camel-case. For a full list of options to the printToPDF function, please see the Chrome documentation at: https://chromedevtools.github.io/devtools-protocol/tot/Page#method-printToPDF Header and footer Chrome&#39;s support for native header and footer sections is a little bit finicky. Still, to the best of my knowledge, headerTemplate and footerTemplate are the only well-functioning solutions if you need headers or footers that are repeated on multiple pages even in the presence of body elements stretching across a page break. In order to make header and footer visible in the first place, you will need to be aware of a couple of caveats: HTML for header and footer is interpreted in a new page context which means no body styles will be applied. In fact, even default browser styles are not present, so all content will have a default font-size of zero, and so on. You need to make space for the header and footer templates first, by adding page margins. Margins can either be given using the marginTop and marginBottom options or with CSS styles. If you use the options, the height of header and footer elements will inherit these values. If you use CSS styles, make sure to set the height of the elements in CSS as well. Header and footer have a default padding to the page ends of 0.4 centimeters. To remote this, add the following to header/footer template styles (source). #header, #footer { padding: 0 !important; } If header or footer is not displayed when it should, make sure your HTML is valid. Tuning the margins for an hour looking for mistakes there, only to discover that you are missing a closing &lt;/style&gt; tag, can be quite painful. Javascript is not interpreted. Background colors are not applied, unless you include set -webkit-print-color-adjust: exact in the CSS. See print_header_footer_template.html from the Chromium sources to see how these values are interpreted. Page size and margins Chrome will use the provided pagerWidth and paperHeight dimensions as the PDF paper format, unless the preferCSSPageSize option is set to true in which case it prioritizes values set in a @page section in the (body) CSS. However, any margin applied to the page using the options above is generally overridden by margin rules in the @page section.","ref":"ChromicPDF.html#print_to_pdf/2","title":"ChromicPDF.print_to_pdf/2","type":"function"},{"doc":"Prints a PDF and converts it to PDF/A in a single call. See print_to_pdf/2 and convert_to_pdfa/2 for options. Example ChromicPDF.print_to_pdfa({:url, &quot;https://example.net&quot;})","ref":"ChromicPDF.html#print_to_pdfa/2","title":"ChromicPDF.print_to_pdfa/2","type":"function"},{"doc":"","ref":"ChromicPDF.html#start_link/1","title":"ChromicPDF.start_link/1","type":"function"},{"doc":"Use this for multiple ChromicPDF instances. When is this useful? You want to completely separate two or more PDF &quot;queues&quot; You want to give your PDF module a custom API Usage defmodule MyApp.MyPDFGenerator do use ChromicPDF.Supervisor end def MyApp.Application do def start(_type, _args) do children = [ MyApp.MyPDFGenerator ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end end","ref":"ChromicPDF.Supervisor.html","title":"ChromicPDF.Supervisor","type":"module"},{"doc":"This module contains helper functions that make it easier to to build HTML templates (body, header, and footer) that fully cover a given page. Like an adapter, it tries to harmonize Chrome&#39;s printToPDF options and related CSS layout styles (@page and friends) with a custom set of page sizing options. Using this module is entirely optional, but perhaps can help to avoid some common pitfalls arising from the slightly unintuitive and sometimes conflicting behaviour of printToPDF options and @page CSS styles in Chrome. One particularly cumbersome detail is that Chrome in headless mode does not correctly interpret the @page CSS rule to configure the page dimensions. Resulting PDF files will always be in US-letter format unless configured differently with the paperWidth and paperHeight options. Experience has shown, that results will be best if the @page rule aligns with the values passed to printToPDF, which is why these helpers exist to make basic page styling a bit easier. For a start, see source_and_options/1.","ref":"ChromicPDF.Template.html","title":"ChromicPDF.Template","type":"module"},{"doc":"Concatenes two HTML strings or iolists into one. From {:safe, iolist} tuples, the :safe is dropped. This is useful to prepare data coming from a Phoenix-compiled .eex template. content = html_concat(@styles, render(&quot;content.html&quot;))","ref":"ChromicPDF.Template.html#html_concat/2","title":"ChromicPDF.Template.html_concat/2","type":"function"},{"doc":"Returns source and options for a PDF to be printed, a given set of template options. The return value can be passed to ChromicPDF.print_to_pdf/2. Options header footer all options from styles/1 Example This example has the dimension of a ISO A4 page. ChromicPDF.Template.source_and_options( content: &quot;&lt;p&gt;Hello&lt;/p&gt;&quot;, header: &quot;&lt;p&gt;header&lt;/p&gt;&quot;, footer: &quot;&lt;p&gt;footer&lt;/p&gt;&quot; size: :a4, header_height: &quot;45mm&quot;, header_font_size: &quot;20pt&quot;, footer_height: &quot;40mm&quot; ) Content, header, and footer templates should be unwrapped HTML markup (i.e. no &lt;html&gt; around the content), prefixed with any &lt;style&gt; tags that your page needs. &lt;style&gt; h1 { font-size: 22pt; } &lt;/style&gt; &lt;h1&gt;Hello&lt;/h1&gt;","ref":"ChromicPDF.Template.html#source_and_options/1","title":"ChromicPDF.Template.source_and_options/1","type":"function"},{"doc":"Renders page styles for given options. These base styles will configure page dimensions and header and footer heights. They also remove any browser padding and margins from these elements, and set the font-size. Additionally, they set the zoom level of header and footer templates to 0.75 which seems to make them align with the content viewport scaling better. Options size page size, either a standard name (:a4, :us_letter) or a {&lt;width&gt;, &lt;height&gt;} tuple in inches, default: :us_letter header_height default: zero header_font_size default: 10pt header_zoom default: 0.75 footer_height default: zero footer_font_size default: 10pt footer_zoom default: 0.75 webkit_color_print_adjust default: &quot;exact&quot;","ref":"ChromicPDF.Template.html#styles/1","title":"ChromicPDF.Template.styles/1","type":"function"},{"doc":"","ref":"ChromicPDF.Template.html#t:blob/0","title":"ChromicPDF.Template.blob/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:content_option/0","title":"ChromicPDF.Template.content_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:paper_size/0","title":"ChromicPDF.Template.paper_size/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:style_option/0","title":"ChromicPDF.Template.style_option/0","type":"type"},{"doc":"ChromicPDF is a HTML-to-PDF renderer for Elixir, based on headless Chrome.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Node-free: In contrast to many other packages, it does not use puppeteer, and hence does not require Node.js. It communicates directly with Chrome&#39;s DevTools API over pipes, offering the same performance as puppeteer, if not better. Header/Footer: Using the DevTools API allows to apply the full set of options of the printToPDF function. Most notably, it supports header and footer HTML templates. PDF/A: It can convert printed files to PDF/A using Ghostscript, inspired by the pdf2archive script originally created by @matteosecli and later enhanced by @JaimeChavarriaga. Created PDF/A-2b and PDF/A-3b files pass the verapdf compliance checks.","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"Chromium or Chrome Ghostscript (for PDF/A support)","ref":"readme.html#requirements","title":"README - Requirements","type":"extras"},{"doc":"ChromicPDF is a supervision tree (rather than an application). You will need to inject it into the supervision tree of your application. First, add ChromicPDF to your runtime dependencies: def deps do [ {:chromic_pdf, &quot;~&gt; 0.5.0&quot;} ] end Next, start ChromicPDF as part of your application: # lib/my_app/application.ex def MyApp.Application do def start(_type, _args) do children = [ # other apps... ChromicPDF ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Main API ChromicPDF.print_to_pdfa( # URL to of local file to print {:url, &quot;file:///example.html&quot;}, # Parameters to the PDF renderer, specifically for Chromium&#39;s printToPDF function, # see https://chromedevtools.github.io/devtools-protocol/tot/Page#method-printToPDF print_to_pdf: %{ # Margins are in given inches marginTop: 0.393701, marginLeft: 0.787402, marginRight: 0.787402, marginBottom: 1.1811, # Print header and footer (on each page). # This will print the default templates if none are given. displayHeaderFooter: true, # Even on empty string. # To disable header or footer, pass an empty element. headerTemplate: &quot;&lt;span&gt;&lt;/span&gt;&quot;, # Example footer template. # They are completely unstyled by default and have a font-size of zero, # so don&#39;t despair if they don&#39;t show up at first. # There&#39;s a lot of documentation online about how to style them properly, # this is just a basic example. The &lt;span&gt; classes shown below are # interpolated by Chrome, see the printToPDF documentation. footerTemplate: &quot;&quot;&quot; &lt;style&gt; p { color: #333; font-size: 10pt; text-align: right; margin: 0 0.787402in; width: 100%; z-index: 1000; } &lt;/style&gt; &lt;p&gt; Page &lt;span class=&quot;pageNumber&quot;&gt;&lt;/span&gt; of &lt;span class=&quot;totalPages&quot;&gt;&lt;/span&gt; &lt;/p&gt; &quot;&quot;&quot; }, # Parameters for the PDF/A converter info: %{ title: &quot;Example&quot;, author: &quot;Jane Doe&quot;, creator: &quot;ChromicPDF&quot; }, pdfa_version: &quot;3&quot;, # Output path. output: &quot;test.pdf&quot; ) Sample boilerplate for a template This more sophisticated example shows how to use Phoenix.View to move HTML markup into template files. defmodule MyApp.InvoiceView do use Phoenix.View, root: &quot;lib/my_app/path/to/pdf_templates&quot;, namespace: MyApp def print_to_pdf(assigns) do [content: content(assigns)] |&gt; ChromicPDF.Template.source_and_options() |&gt; ChromicPDF.print_to_pdf() end @style File.read!(&quot;../path/to/assets/css/invoice.css&quot;) defp content(assigns) do [ @style, Phoenix.HTML.safe_to_string(render(&quot;content.html&quot;, assigns)) ] end end","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"For running the full suite of integration tests, please install and have in your $PATH: verapdf For pdfinfo and pdftotext, you need poppler-utils (most Linux distributions) or Xpdf (OSX) For the odd ZUGFeRD test in pdfa_generation_test.exs, you need to download ZUV and set the $ZUV_JAR environment variable.","ref":"readme.html#development","title":"README - Development","type":"extras"}]